var MIN_SOUND_TIME = 800;
var MAX_SOUND_TIME = 1000*60;
mui.init({
	gestureConfig: {
		tap: true, //默认为true
		doubletap: true, //默认为false
		longtap: true, //默认为false
		swipe: true, //默认为true
		drag: true, //默认为true
		hold: true, //默认为false，不监听
		release: true //默认为false，不监听
	}
});

mui.ready(function() {
	//初始化本地存储
	initDb();
	//页面初始化
	pageshow_init();
	//添加事件
	addListener();
	
	//定义返回地址
	overWriteBack("xiaoxi.html","",true);
});

var conn;		//环信连接
var to;			//环信id（消息接收者）
var nickname;	//环信nickname（消息接收者）
var avatar;		//环信头像（消息接收者）
var avatar_my;		//环信头像（消息接收者）
/**
 * 回调：消息接收（easemob消息推送）
 * @param {Object} content
 */
var callback_message = function(type,content,from_em){
	if(from_em == to){
		displayMessage({
			sender: 'easemob',
			type: type,
			content: content
		});
	}
}

//页面初始化
function pageshow_init(){
	console.info('chat pageshow_init()');
	if(!isLogin()){
		mui.toast('用户未登录，请先登录！');
	}
	
	var chatMsgInfo = localStorage.getItem("chatMsgInfo");
	var chatMsgInfo_json = JSON.parse(chatMsgInfo); //由JSON字符串转换为JSON对象;
	to = chatMsgInfo_json.emid;
	nickname = chatMsgInfo_json.nickname;
	avatar = chatMsgInfo_json.avatar;
	avatar_my = getMember().headimg;
	if(!avatar_my){
		avatar_my = AVATAR_DEFAULT;
	}
	document.querySelector('#nickname').innerText = nickname;
	
	if(to == ADMIN_EM || to == GLZHELPER_EM){
		document.querySelector('footer').style.display='none';
	}else{
		document.querySelector('footer').style.display='block'; 
	}
	document.querySelector('footer');
	//数据库加载-兼容LocalStorage模式
	var callback_loadDb = function(){
		var owner = getMemberEmid();
			
		var messageList = Message_chat.all().filter("owner", '=', owner).and(new persistence.PropertyFilter("emid", '=', to)).order("createdate", false).limit(20);
		messageList.list(null, function (messages) {
			for(i=messages.length;i>0;i--){
				var message = messages[i-1];
				var type;
		    	var type_db = message.type;
		    	if(type_db == '1'){
		    		type = MESSAGE_TYPE_TEXT;
		    	}else if(type_db == '3'){
		    		type = MESSAGE_TYPE_IMAGE;
		    	}else if(type_db == '5'){
		    		type = MESSAGE_TYPE_SOUND;
		    	}
		    	
		    	if(type){
//				    		console.info("message:"+JSON.stringify(message));
		    		displayMessage({
						sender: message.sender,
						type: type,
						content: message.content
					});
		    	}
			}
		});
		
		//环信初始化
		conn = easemobInit(null,callback_message);
	}
	loadDb(callback_loadDb);
}

/**
 * 页面显示事件
 */
document.body.onpageshow = function(){
	
}
/**
 * 页面隐藏事件
 */
document.body.onpagehide = function(){
	
}

/**
 * 添加事件
 */
function addListener(){
	/**
	 * 显示会员详情
	 */
	document.getElementById("memberInfoBtn").addEventListener('tap', function(event) {
		//通过本地存储用户信息自动登录
		mui.ajax(BASE_URL+'/members/getMemberInfoByEmid.action',{
			data:{
				emid: to
			},
			dataType:'json',//服务器返回json格式数据
			type:'get',//HTTP请求类型
			success:function(data){
//							console.log(JSON.stringify(data));
				if(data.success) {
					var memberInfo = data.data;
					var id = memberInfo.id;
					localStorage.setItem("memberInfo_id",id); 
 					openwindow(my_detailTab);
				}
			},
			error:function(xhr,type,errorThrown){

			}
		});
	}, false);
	
	/**
	 * 超链接
	 */
	mui("#msg-list").on('tap','div.chat_tt',function(event) {
		var div = this;
		var url = div.getAttribute("data-url");
		if(url)
			openwindow(url);
	}, false);
	
}

/**
 * 官网自带聊天代码
 */
template.config('escape', false);
//mui.plusReady=function(fn){fn();};
//	mui.plusReady(function() {
//		plus.webview.currentWebview().setStyle({
//			softinputMode: "adjustResize"
//		});
//	});

var showKeyboard = function() {
		if (mui.os.ios) {
			var webView = plus.webview.currentWebview().nativeInstanceObject();
			webView.plusCallMethod({
				"setKeyboardDisplayRequiresUserAction": false
			});
		} else {
			var Context = plus.android.importClass("android.content.Context");
			var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
			var main = plus.android.runtimeMainActivity();
			var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
			imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
			//var view = ((ViewGroup)main.findViewById(android.R.id.content)).getChildAt(0);
			imm.showSoftInput(main.getWindow().getDecorView(), InputMethodManager.SHOW_IMPLICIT);
			//alert("ll");
		}
	};
	var record = [];
	var ui = {
		body: document.querySelector('body'),
		header: document.querySelector('header'),
		footer: document.querySelector('footer'),
		footerRight: document.querySelector('.footer-right'),
		footerLeft: document.querySelector('.footer-left'),
		btnMsgType: document.querySelector('#msg-type'),
		boxMsgText: document.querySelector('#msg-text'),
		boxMsgSound: document.querySelector('#msg-sound'),
		btnMsgImage: document.querySelector('#msg-image'),
		areaMsgList: document.querySelector('#msg-list'),
		boxSoundAlert: document.querySelector('#sound-alert'),
		h: document.querySelector('#h'),
		content: document.querySelector('.mui-content')
	};
	ui.h.style.width = ui.boxMsgText.offsetWidth + 'px';
	//alert(ui.boxMsgText.offsetWidth );
	var footerPadding = ui.footer.offsetHeight - ui.boxMsgText.offsetHeight;
	//header padding
	ui.content.style.paddingTop = ui.header.offsetHeight+ 'px';
	ui.content.style.paddingBottom = ui.footer.offsetHeight+ 'px';
	var msgItemTap = function(msgItem, event) {
		var msgType = msgItem.getAttribute('msg-type');
		var msgContent = msgItem.getAttribute('msg-content')
		if (msgType == MESSAGE_TYPE_SOUND) {
			player = plus.audio.createPlayer(msgContent);
			var playState = msgItem.querySelector('.play-state');
			playState.innerText = '正在播放...';
			player.play(function() {
				playState.innerText = '点击播放';
			}, function(e) {
				playState.innerText = '点击播放';
			});
		}
	};
	var imageViewer = new mui.ImageViewer('.msg-content-image', {
		dbl: false
	});
	var bindMsgList = function() {
		//绑定数据:
		/*tp.bind({
			template: 'msg-template',
			element: 'msg-list',
			model: record
		});*/
		
		ui.areaMsgList.innerHTML = template('msg-template', {
			"record": record
		});
		var msgItems = ui.areaMsgList.querySelectorAll('.msg-item');
		[].forEach.call(msgItems, function(item, index) {
			item.addEventListener('tap', function(event) {
				msgItemTap(item, event);
			}, false);
		});
		imageViewer.findAllImage();
		ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
	};
	bindMsgList();
	window.addEventListener('resize', function() {
		ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
	}, false);
	var displayMessage = function(msg) {
		msg.avatar = avatar;
		msg.avatar_my = avatar_my;
		record.push(msg);
		bindMsgList();
	};

	function msgTextFocus() {
			ui.boxMsgText.focus();
			setTimeout(function() {
				ui.boxMsgText.focus();
			}, 150);
		}
		//解决长按“发送”按钮，导致键盘关闭的问题；
	ui.footerRight.addEventListener('touchstart', function(event) {
		if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
			msgTextFocus();
			event.preventDefault();
		}
	});
	//解决长按“发送”按钮，导致键盘关闭的问题；
	ui.footerRight.addEventListener('touchmove', function(event) {
		if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
			msgTextFocus();
			event.preventDefault();
		}
	});
	//					ui.footerRight.addEventListener('touchcancel', function(event) {
	//						if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
	//							msgTextFocus();
	//							event.preventDefault();
	//						}
	//					});
	//					ui.footerRight.addEventListener('touchend', function(event) {
	//						if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
	//							msgTextFocus();
	//							event.preventDefault();
	//						}
	//					});
	ui.footerRight.addEventListener('release', function(event) {
	if (ui.btnMsgType.classList.contains('mui-icon-paperplane')) {
		//showKeyboard();
		ui.boxMsgText.focus();
		setTimeout(function() {
			ui.boxMsgText.focus();
		}, 150);
		//							event.detail.gesture.preventDefault();
		var content = ui.boxMsgText.value.replace(new RegExp('\n', 'gm'), '<br/>');
		/**
		 * 环信：发送文本消息
		 */
		conn.sendTextMessage({
		    to : to,
		    msg : content,
		    ext :{}//用户自扩展的消息内容（群聊用法相同）
		});
		var message_json = {
			sender: 'self',
			type: MESSAGE_TYPE_TEXT,
			content: content
		}
		displayMessage(message_json);
		//console.info(WebIM.utils.parseEmoji("[8-)]你好！"));
		//<li key="[+o(]" class="webim-emoji-item"><img src="demo/images/faces/ee_16.png"></li>
		//<pre><img class="emoji" src="demo/images/faces/ee_28.png">趟</pre>		
		saveMessage(to,message_json.type,message_json.content,message_json.sender);
		ui.boxMsgText.value = '';
		mui.trigger(ui.boxMsgText, 'input', null);
	} else if (ui.btnMsgType.classList.contains('mui-icon-mic')) {
		if (mui.os.plus) {
			ui.btnMsgType.classList.add('mui-icon-compose');
			ui.btnMsgType.classList.remove('mui-icon-mic');
			ui.boxMsgText.style.display = 'none';
			ui.boxMsgSound.style.display = 'block';
			ui.boxMsgText.blur();
			document.body.focus();
		}else{
			mui.toast("此版本不支持语音发送，请下载APP");
		}
	} else if (ui.btnMsgType.classList.contains('mui-icon-compose')) {
		ui.btnMsgType.classList.add('mui-icon-mic');
		ui.btnMsgType.classList.remove('mui-icon-compose');
		ui.boxMsgSound.style.display = 'none';
		ui.boxMsgText.style.display = 'block';
		//--
		//showKeyboard();
		ui.boxMsgText.focus();
		setTimeout(function() {
			ui.boxMsgText.focus();
		}, 150);
	}
}, false);
ui.footerLeft.addEventListener('tap', function(event) {
	// 选择图片
	var fileInput = document.createElement('input');
	fileInput.setAttribute('id', 'pictureInput');
	fileInput.setAttribute('type', 'file');
	fileInput.setAttribute('accept', 'image/*');
	fileInput.addEventListener('change', function(event) {
		var fileSelected = fileInput.files[0];
		if(fileSelected) {
			var id = conn.getUniqueId();
			var msg = new WebIM.message('img', id);
			var input = document.getElementById('pictureInput'); //选择图片的input
			var file = WebIM.utils.getFileUrl(input);
			var allowType = {
				"jpg": true,
				"gif": true,
				"png": true,
				"bmp": true
			};
			console.info(file.filetype.toLowerCase());
			if(file.filetype.toLowerCase() in allowType) {
				/**
				 * 环信：发送图片
				 */
				msg.set({
					apiUrl: Easemob.im.config.apiURL,
					file: file,
					to: to,
					onFileUploadError: function(error) {
						console.log(JSON.stringify(error));
						mui.toast('图片上传失败！');
					}, //图片上传失败
					onFileUploadComplete: function(data) {
						console.log("发送成功,图片地址："+data.uri + '/' + data.entities[0].uuid);
						content = data.uri + '/' + data.entities[0].uuid;
						//执行下载
						downloadImage(content,function(path){
							content = path;
							//显示并保存图片消息
							var message_json = {
								sender: 'self',
								type: MESSAGE_TYPE_IMAGE,
								content: content
							};
							displayMessage(message_json);
							saveMessage(to,message_json.type,message_json.content,message_json.sender);
						});
						//图片地址：data.uri + '/' + data.entities[0].uuid;
//							var reader = new FileReader();
//							reader.onload = function() {
//								//处理 android 4.1 兼容问题
//								var base64 = reader.result.split(',')[1];
//								var dataUrl = 'data:image/png;base64,' + base64;
//								// 消息展示
//								displayMessage({
//									sender: 'self',
//									type: MESSAGE_TYPE_IMAGE,
//									content: dataUrl
//								});
//							}
//							reader.readAsDataURL(fileSelected);
					},
					success: function(id, serverMsgId) {}, //图片消息发送成功
					flashUpload: WebIM.flashUpload
				});

				conn.send(msg.body);
			}else{
				mui.toast('不支持的文件类型：'+file.filetype);
			}
		}
	}, false);
	document.querySelector(".footer-left").appendChild(fileInput);
}, false);
var setSoundAlertVisable=function(show){
	if(show){
		ui.boxSoundAlert.style.display = 'block';
		ui.boxSoundAlert.style.opacity = 1;
	}else{
		ui.boxSoundAlert.style.opacity = 0;
		//fadeOut 完成再真正隐藏
		setTimeout(function(){
			ui.boxSoundAlert.style.display = 'none';
		},200);
	}
};
var recordCancel = false;
var recorder = null;
var audio_tips = document.getElementById("audio_tips");
var startTimestamp = null;
var stopTimestamp = null;
var stopTimer = null;
ui.boxMsgSound.addEventListener('hold', function(event) {
	recordCancel = false;
	if(stopTimer)clearTimeout(stopTimer);
	audio_tips.innerHTML = "手指上划，取消发送";
	ui.boxSoundAlert.classList.remove('rprogress-sigh');
	setSoundAlertVisable(true);
	recorder = plus.audio.getRecorder();
	if (recorder == null) {
		plus.nativeUI.toast("不能获取录音对象");
		return;
	}
	startTimestamp = (new Date()).getTime();
	recorder.record({
		filename: "_doc/audio/"
	}, function(path) {
		if (recordCancel) return;
		plus.io.resolveLocalFileSystemURL(path, function(entry){
	        entry.file(function(file){
	            var reader = new plus.io.FileReader();
	            reader.onloadend = function (e) {
	                var data = e.target.result;

	                console.info("发送语音文件，路径："+path+"，大小："+data.length);
					
					//环信： 发送语音信息（基于base64编码的文本消息）
					conn.sendTextMessage({
					    to : to,
					    msg : data,
					    ext :{action:MESSAGE_TYPE_SOUND}//用户自扩展的消息内容（群聊用法相同）
					});
				};
	            reader.readAsDataURL(file);
	        },function(e){
	            mui.toast("读写出现异常: " + e.message );
	        })
	    })
		var message_json = {
			sender: 'self',
			type: MESSAGE_TYPE_SOUND,
			content: path
		};
		displayMessage(message_json);
		saveMessage(to,message_json.type,message_json.content,message_json.sender);
	}, function(e) {
		plus.nativeUI.toast("录音时出现异常: " + e.message);
	});
}, false);
ui.body.addEventListener('drag', function(event) {
	//console.log('drag');
	if (Math.abs(event.detail.deltaY) > 50) {
		if (!recordCancel) {
			recordCancel = true;
			if (!audio_tips.classList.contains("cancel")) {
				audio_tips.classList.add("cancel");
			}
			audio_tips.innerHTML = "松开手指，取消发送";
		}
	} else {
		if (recordCancel) {
			recordCancel = false;
			if (audio_tips.classList.contains("cancel")) {
				audio_tips.classList.remove("cancel");
			}
			audio_tips.innerHTML = "手指上划，取消发送";
		}
	}
}, false);
ui.boxMsgSound.addEventListener('release', function(event) {
	//console.log('release');
	if (audio_tips.classList.contains("cancel")) {
		audio_tips.classList.remove("cancel");
		audio_tips.innerHTML = "手指上划，取消发送";
	}
	//
	stopTimestamp = (new Date()).getTime();
	if (stopTimestamp - startTimestamp < MIN_SOUND_TIME) {
		audio_tips.innerHTML = "录音时间太短";
		ui.boxSoundAlert.classList.add('rprogress-sigh');
		recordCancel = true;
		stopTimer=setTimeout(function(){
			setSoundAlertVisable(false);
		},1500);
	}else if (stopTimestamp - startTimestamp > MAX_SOUND_TIME) {
		audio_tips.innerHTML = "语音文件过大，最长录音时间1分钟";
		ui.boxSoundAlert.classList.add('rprogress-sigh');
		recordCancel = true;
		stopTimer=setTimeout(function(){
			setSoundAlertVisable(false);
		},1500);
	}else{
		setSoundAlertVisable(false);
	}
	recorder.stop();
}, false);
ui.boxMsgSound.addEventListener("touchstart", function(e) {
	//console.log("start....");
	e.preventDefault();
});
ui.boxMsgText.addEventListener('input', function(event) {
	ui.btnMsgType.classList[ui.boxMsgText.value == '' ? 'remove' : 'add']('mui-icon-paperplane');
	ui.btnMsgType.setAttribute("for", ui.boxMsgText.value == '' ? '' : 'msg-text');
	ui.h.innerText = ui.boxMsgText.value.replace(new RegExp('\n', 'gm'), '\n-') || '-';
	ui.footer.style.height = (ui.h.offsetHeight + footerPadding) + 'px';
	ui.content.style.paddingBottom = ui.footer.style.height;
});
var focus = false;
ui.boxMsgText.addEventListener('tap', function(event) {
	ui.boxMsgText.focus();
	setTimeout(function() {
		ui.boxMsgText.focus();
	}, 0);
	focus = true;
	setTimeout(function () {
		focus = false;
	},1000);
	event.detail.gesture.preventDefault();
}, false);
//点击消息列表，关闭键盘
ui.areaMsgList.addEventListener('click',function (event) {
	if(!focus){
		ui.boxMsgText.blur();
	}
})
