var MESSAGE_TYPE_TEXT = 'text';
var MESSAGE_TYPE_EMOJI = 'emoji';
var MESSAGE_TYPE_IMAGE = 'image';
var MESSAGE_TYPE_SOUND = 'sound';
var MESSAGE_TYPE_HREF = 'href';

var LOGIC_YES = '1';
var LOGIC_NO = '0';

var AVATAR_DEFAULT = '../images/persiondefault.png';
var AVATAR_SYSTEM = '../images/new2.png';
var AVATAR_GLZHELPER = '../images/new3.png';

var ADMIN_EM = 'admin';
var GLZHELPER_EM = 'glzxzs';

var CONTACT_TYPE_SYSTEM = '2';
var CONTACT_TYPE_MESSAGE = '3';
var CONTACT_TYPE_GLZHELPER = '4';
/**
 * easemob环信用户登录
 */
function easemobLogin(){
	var memberInfo=getMember();
	if(!memberInfo)
		return null;
		
	var emid = memberInfo.emid;
	WebIM.Emoji = {
	    path: 'faces/'  /*表情包路径*/
	    , map: {
	        "[8-)]":"ee_23.png",
			"[8-|]":"ee_15.png",
			"[8o|]":"ee_14.png",
			"[(#)]":"ee_28.png",
			"[(*)]":"ee_27.png",
			"[(D)]":"ee_35.png",
			"[(F)]":"ee_33.png",
			"[(H)]":"ee_6.png",
			"[(R)]":"ee_29.png",
			"[(S)]":"ee_26.png",
			"[(W)]":"ee_34.png",
			"[(a)]":"ee_13.png",
			"[(k)]":"ee_32.png",
			"[(u)]":"ee_25.png",
			"[({)]":"ee_30.png",
			"[(|)]":"ee_24.png",
			"[(})]":"ee_31.png",
			"[):]":"ee_1.png",
			"[*-)]":"ee_19.png",
			"[+o(]":"ee_16.png",
			"[:$]":"ee_9.png",
			"[:'(]":"ee_11.png",
			"[:(]":"ee_10.png",
			"[:-#]":"ee_20.png",
			"[:-*]":"ee_21.png",
			"[:-o]":"ee_4.png",
			"[:@]":"ee_7.png",
			"[:D]":"ee_2.png",
			"[:p]":"ee_5.png",
			"[:s]":"ee_8.png",
			"[:|]":"ee_12.png",
			"[;)]":"ee_3.png",
			"[<o)]":"ee_17.png",
			"[^o)]":"ee_22.png",
			"[|-)]":"ee_18.png"
	    }
	}
	
	// easemob创建一个新的连接
	var conn = new Easemob.im.Connection({
	    isMultiLoginSessions: WebIM.config.isMultiLoginSessions,
	    https: typeof WebIM.config.https === 'boolean' ? WebIM.config.https : location.protocol === 'https:',
	    url: WebIM.config.xmppURL,
	    isAutoLogin: false
	});
	// easemob初始化连接
	conn.init({
		onOpened: function() {
//			conn.setPresence();
			console.log('环信已自动登录，环信用户ID：'+emid);
		}
	});
	
	// easemob打开连接
	conn.open({
		user: emid,
		pwd: Easemob.im.config.password,
		apiUrl: Easemob.im.config.apiURL,
		appKey: Easemob.im.config.appkey
	});
	
	return conn;
}

/**
 * 环信初始化
 */
function easemobInit(callback_presence,callback_message){
	conn = easemobLogin();
	var memberInfo=getMember();
	if(!memberInfo)
		return null;
	
	conn.listen({
		onOpened: function() {
			conn.setPresence();
			console.log('环信已自动登录，环信用户ID：'+memberInfo.emid);
		},
		onClosed: function ( message ) {
//			console.log('环信已断开连接');
		},         //连接关闭回调
	  	onTextMessage: function(message) {
	  		handleMessage(message,MESSAGE_TYPE_TEXT);
	  	}, //收到文本消息 
	  	onEmojiMessage: function(message) {
	  		message = WebIM.utils.parseEmoji(message);
	  		handleMessage(message,MESSAGE_TYPE_TEXT);
	  	}, //收到表情消息
	  	onPictureMessage: function(message) {
	  		handleMessage(message,MESSAGE_TYPE_IMAGE);
	  	}, //收到图片消息
	  	onCmdMessage: function(message) {
	  		handleMessage(message,'cmd');
	  	}, //收到命令消息
	  	onAudioMessage: function(message) {
	  		handleMessage(message,MESSAGE_TYPE_SOUND);
	  	}, //收到音频消息
	  	onLocationMessage: function(message) {}, //收到位置消息
	  	onFileMessage: function(message) {}, //收到文件消息
	  	onVideoMessage: function(message) {}, //收到视频消息
	  	onPresence: function(message) {
	  		handlePresence(message);
	  	}, //收到联系人订阅请求、处理群组、聊天室被踢解散等消息
	  	onRoster: function(message) {}, //处理好友申请
	  	onInviteMessage: function(message) {}, //处理群组邀请
	  	onOnline: function() {}, //本机网络连接成功
	  	onOffline: function() {}, //本机网络掉线
	  	onError: function(message) {} //失败回调		
	});
	
	/**
	 * 添加好友请求
	 * @param {Object} e
	 */
	var handlePresence = function(e) {
//		console.log(JSON.stringify(e));
		//收到添加好友请求
		if (e.type == 'subscribe') {
			var data ={
				emid:e.from,
				nickname:e.status
			}
			
			callback_presence&&callback_presence(data);
		}
		//对方拒绝添加好友请求或对方删除好友
	    if (e.type == 'unsubscribed') {
	        
	    }
	};
	
	/**
	 * 接受消息
	 * @param {Object} message
	 * @param {Object} type
	 */
	var lastMsgTime = new Date().getTime();
	var handleMessage = function(message, type){
		console.log(JSON.stringify(message));
		var content = '';
		if(type == MESSAGE_TYPE_TEXT){
			if(message.ext.action){
				/**
				 * 接收语音信息（基于base64编码的文本消息）
				 */
				if(message.ext.action==MESSAGE_TYPE_SOUND){
					type=MESSAGE_TYPE_SOUND;
					// 转成.amr文件
					var base64Str = message.data;
				    dataURL2Audio(base64Str, function(entry){
				        content = entry.toURL();
				        //保存消息并回调
				        saveMessage(message.from,type,content,'easemob',message.delay,function(){
				        	console.info("接收语音文件并解码成功，路径："+content);
							callback_message&&callback_message(type,content,message.from);
				        });
				    })
				    
				 /**
				 * 接收href信息（基于html dom）
				 */   
				}else if(message.ext.action==MESSAGE_TYPE_HREF){
					type=MESSAGE_TYPE_HREF;
					
					content = message.data;
					content = content.replace(/'/g, '"');
					//保存消息并回调
			        saveMessage(message.from,type,content,'easemob',message.delay,function(){
			        	callback_message&&callback_message(type,content,message.from);
			        });
				}
			/**
			 * 接收文本消息
			 */
			}else{
				var message_type = message.type;	//groupchat,chat

				content = message.data;
				//保存消息并回调
		        saveMessage(message.from,type,content,'easemob',message.delay,function(){
		        	callback_message&&callback_message(type,content,message.from);
		        });
				
			}
		/**
		 * 接收图片消息
		 */	
		}else if(type == MESSAGE_TYPE_IMAGE){
			content = message.url;
			//执行下载
			downloadImage(content,function(path){
				content = path;
				//保存消息并回调
		        saveMessage(message.from,type,content,'easemob',message.delay,function(){
		        	callback_message&&callback_message(type,content,message.from);
		        });
				
			});
		}else if(type == MESSAGE_TYPE_SOUND){
			
		}
		
		/**
		 * 消息提醒
		 */
		var now = new Date().getTime();
		if(now - lastMsgTime > 1000){
			player();
		}
		lastMsgTime = now;
	} 
	
	
	
	
	return conn;
}


/**
 * 最近联系人消息显示
 * @param {Object} type
 * @param {Object} content
 */
function getContactcontent(type,content){
	var content_contact = content;
	if(type == MESSAGE_TYPE_TEXT){
	}else if(type == MESSAGE_TYPE_IMAGE){
		content_contact = '[图片]'
	}else if(type == MESSAGE_TYPE_SOUND){
		content_contact = '[语音]'
	}else if(type == MESSAGE_TYPE_HREF){
		var div = document.createElement("div");
		var id = "virtual-div-href";
		div.id = id;
		div.style.display = 'none';
		document.body.appendChild(div);

       	div.innerHTML = content;
		var spans = document.getElementById(id).querySelectorAll("span");
		if(spans && spans.length>0){
			for(i =0;i<spans.length;i++){
				var span = spans[i];
				if(span.getAttribute('name') == 'title'){
					content_contact = '[链接]' + span.innerHTML; 
					break;
				}
			}
		}
		document.body.removeChild(document.getElementById(id));
	}
	return content_contact;
}
/**
 * 消息持久化存储
 */
function saveMessage(emid,type,content,sender,delay,callback){
	var owner = getMemberEmid();
	
	var type_db ;
	var content_contact = getContactcontent(type,content);
	if(type == MESSAGE_TYPE_TEXT || type == MESSAGE_TYPE_HREF){
		type_db = '1';
	}else if(type == MESSAGE_TYPE_IMAGE){
		type_db = '3';
	}else if(type == MESSAGE_TYPE_SOUND){
		type_db = '5';
	}
	var createdate = new Date().getTime();
//	if(delay)
//		createdate = new Date(delay).getTime();
	//消息本地存储
	var message = new Message_chat({
		owner: owner,
		emid: emid,
		sender: sender,
		type: type_db,
		content: content,
		createdate: createdate,
		status: LOGIC_YES
	});
	persistence.add(message);
	commitDb();
	
	//更新最近联系人，最近时间、最近消息
	var contactList = Contact_chat.all().filter("owner", '=', owner).and(new persistence.PropertyFilter("emid", '=', emid)).limit(1);
	contactList.list(null, function (contacts) {
	    var contact = contacts[0];
	    
	    if(contact){
	    	contact.lastdate = new Date().FormatFull(true);
		    contact.lastmsg = content_contact;
		    
		    commitDb();
		    callback && callback();
	    }else{
	    	//根据emid查询用户信息
			mui.get(BASE_URL+'/members/getMemberInfoByEmid.action', {
				emid : emid
			}, 
			function(data) {
				if(data.success) {
					//头像
					var avatar = data.data.headimg;
					if(avatar==''||avatar==null){
						avatar = AVATAR_DEFAULT;
					}
					var type_contact = CONTACT_TYPE_MESSAGE;
					var nickname = data.data.nickname;
					if(emid == ADMIN_EM){
						type_contact = CONTACT_TYPE_SYSTEM;
						nickname = '管理员';
						avatar = AVATAR_SYSTEM;
					}else if(emid == GLZHELPER_EM){
						type_contact = CONTACT_TYPE_GLZHELPER;
						nickname = '橄榄枝小助手';
						avatar = AVATAR_GLZHELPER;
					}
					var now = new Date().FormatFull(true);
					var contact = {
						emid: emid,
						type: type_contact,
						nickname: nickname,
						avatar: avatar,
						lastdate: now,
						lastmsg: content_contact,
						status: LOGIC_YES
					};
					saveContact(contact.emid,contact.type,contact.nickname,contact.avatar,contact.lastdate,contact.lastmsg);
				}else{
					
				}
				callback && callback();
			});
	    }
	});
	
	
}

/**
 * 保存最近联系人
 * @param {Object} emid
 * @param {Object} type
 * @param {Object} nickname
 * @param {Object} avatar
 * @param {Object} lastdate
 * @param {Object} lastmsg
 */
function saveContact(emid,type,nickname,avatar,lastdate,lastmsg){
	var owner = getMemberEmid();
	
	var contactList = Contact_chat.all().filter("owner", '=', owner).and(new persistence.PropertyFilter("emid", '=', emid)).limit(1);
	contactList.list(null, function (contacts) {
	    var contact = contacts[0];
	    
	    /**
	     * 消息同步，先删除再添加
	     */
	    if(contact){
	    	//删除最近联系人
	    	Contact_chat.all().remove(contact);
	    	commitDb();
	    }
	    
	    //新增最近联系人
    	if(!lastdate){
			lastdate = new Date().FormatFull(true);
		}
		
		var contact_new = new Contact_chat({
			owner: owner,
			emid: emid,
			type: type,
			nickname: nickname,
			avatar: avatar,
			lastdate: lastdate,
			lastmsg: lastmsg,
			status: LOGIC_YES
		});
		persistence.add(contact_new);
		commitDb();
	});
	    
	
	
}



/**
 * base64字符串转成语音文件
 * @param {Object} base64Str
 * @param {Object} callback
 */
function dataURL2Audio (base64Str, callback) {
	console.info("接受语音消息，大小："+base64Str.length);
    var base64Str = base64Str.replace('data:audio/amr;base64,','');
    var audioName = (new Date()).valueOf() + '.amr';

    plus.io.requestFileSystem(plus.io.PUBLIC_DOCUMENTS,function(fs){
        fs.root.getFile(audioName,{create:true},function(entry){
            // 获得平台绝对路径
            var fullPath = entry.fullPath;
            if(mui.os.android){  
                // 读取音频
                var Base64 = plus.android.importClass("android.util.Base64");
                var FileOutputStream = plus.android.importClass("java.io.FileOutputStream");
                try{
                    var out = new FileOutputStream(fullPath);
                    console.info("语音文件解码全路径："+fullPath);
                    var bytes = Base64.decode(base64Str, Base64.DEFAULT);
                    out.write(bytes); 
                    out.close();
                    // 回调
                    callback && callback(entry);
                }catch(e){
                    console.info("语音文件解码异常："+e.message);
                }
            }else if(mui.os.ios){
                var NSData = plus.ios.importClass('NSData');
                var nsData = new NSData();
                nsData = nsData.initWithBase64EncodedStringoptions(base64Str,0);
                if (nsData) {
                    nsData.plusCallMethod({writeToFile: fullPath,atomically:true});
                    plus.ios.deleteObject(nsData);
                }
                // 回调
                callback && callback(entry);
            }
        })
    })
}

/**
 * 文件下载
 * @param {Object} imageUrl
 */
function downloadImage(imageUrl,callback){
	if (mui.os.plus){
		var hb_path = '_downloads/image/' + md5(imageUrl) + '.jpg'; //HBuilder平台路径
		var sd_path = plus.io.convertLocalFileSystemURL(hb_path); //SD卡绝对路径
		var task = plus.downloader.createDownload(imageUrl, {
			"filename": hb_path,
			"timeout": 10,
			"retry": 2
		}, function(download, status) {
			console.log("下载回调status==" + status+"-->"+hb_path);
			if (status == 200) {
				// 回调
				console.log("图片本地化存储，路径：" + sd_path);
	            callback && callback(sd_path);
			}else{
				//下载失败,取消下载任务,需删除本地临时文件,否则下次进来时会检查到图片已存在
				//download.abort();取消任务,但有时会删除文件失败,固使用delFile(hb_path)先进行删除
				delFile(hb_path);
				download.abort();
				// 回调
	            callback && callback(imageUrl);
			}
		});
		task.start();
	}else{
		callback && callback(imageUrl);
	}
}

/*删除指定文件*/
function delFile(hb_path) {
	if (hb_path) {
		plus.io.resolveLocalFileSystemURL(hb_path, function(entry) {
			entry.remove(function(entry) {
//				console.log("文件删除成功==" + hb_path);
			}, function(e) {
//				console.log("文件删除失败=" + hb_path);
			});
		});
	}
}

/**
 * 播放提示音、震动
 */
function player(){
    if (mui.os.plus){
//  	plus.device.setVolume( 0.5 ); 
		var messageRemind = localStorage.getItem("messageRemind");
		if(!messageRemind)
			messageRemind = '1';
		
	    //响铃
	    if(messageRemind == '1'){
	    	var player = plus.audio.createPlayer("_www/assets/audio/7499.wav" );
		    player.play( function () {//播放完成回调
		        
		    }, function ( e ) {//失败回调
		        alert( "Audio play error: " + e.message ); 
		    } );
		    //plus.device.beep( 2 );
	    }else if(messageRemind == '2'){
	    	//震动
			plus.device.vibrate( 500 );
	    }
    }
}

/**
 * 缩略日期显示
 * @param {Object} dateStr
 */
function getShortDate(dateStr){
	var date = StringToDateFull(dateStr);
	var now_short = date.Format('MM-DD hh:mm',true);
	return now_short;
}
