
/**
 * 计算时间差
 * @param {Object} dateTimeStamp
 */

Handlebars.registerHelper("calculateDate", function(timestamp) {
		
						  
		return getDateDiff(timestamp);
});

/**
 * 判断是否显示删除按钮
 * 
 */

Handlebars.registerHelper("isShowDelete", function(dmemberid,options) {

		 if(memberid==dmemberid){
             //满足添加继续执行
             return options.fn(this);
           }else{
            
            return options.inverse(this);
           }
});


/**
 * 判断是活动是否结束
 * 
 */
Handlebars.registerHelper("isEventsEnd", function(status,options) {
		 if(status==2){
             //满足添加继续执行
             return options.fn(this);
           }else{
            
            return options.inverse(this);
           }
});


/**
 * 判断列表是否为空
 * 
 */
Handlebars.registerHelper("isEmpty", function(list,options) {
		 if(list==null||list.length==0){
             //满足添加继续执行
             return options.fn(this);
           }else{
            return options.inverse(this);
           }
});


/**
 * 计算时间差
 * @param {Object} dateTimeStamp
 */
function getDateDiff(dateTimeStamp){
	dateTimeStamp = dateTimeStamp.replace(/-/g,"/");
	dateTimeStamp = Date.parse(new Date(dateTimeStamp));
	var minute = 1000 * 60;
	var hour = minute * 60;
	var day = hour * 24;
	var halfamonth = day * 15;
	var month = day * 30;
	var now = new Date().getTime();
	var diffValue = now - dateTimeStamp;
	if(diffValue < 0){return;}
	var monthC =diffValue/month;
	var weekC =diffValue/(7*day);
	var dayC =diffValue/day;
	var hourC =diffValue/hour;
	var minC =diffValue/minute;
	
	var d = new Date(dateTimeStamp);
	var curr_date = d.getDate();
	var curr_month = d.getMonth() + 1; //Months are zero based
	
	if(monthC>=1){
		//result="" + parseInt(monthC) + "月前";
		result="" +curr_month + "月"+curr_date+"日";
	}
	else if(weekC>=1){
		//result="" + parseInt(weekC) + "周前";
		result="" +curr_month + "月"+curr_date+"日";
	}
	else if(dayC>=1){
		result=""+ parseInt(dayC) +"天前";
	}
	else if(hourC>=1){
		result=""+ parseInt(hourC) +"小时前";
	}
	else if(minC>=1){
		result=""+ parseInt(minC) +"分钟前";
	}else{
		result="刚刚";
	}
		
	return result;
}