//构造jssdk参数
mui.ready(function() {

	if(mui.os.wechat) {
		var targetUrl = location.href.split("#")[0];
		//console.log('targetUrl=='+targetUrl);
		mui.get('/weixin/createWeixinSDK.action', {
			url: targetUrl
		}, function(data) {
			if(data.success) { 
				var wxDate = data.data;
				//console.log('wxDate=='+wxDate);
				wx.config({
					debug: false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
					appId: wxDate.appid, // 必填，公众号的唯一标识
					timestamp: wxDate.timestamp, // 必填，生成签名的时间戳
					nonceStr: wxDate.nonceStr, // 必填，生成签名的随机串
					signature: wxDate.signature, // 必填，签名，见附录1
					jsApiList: [
							'checkJsApi',
							'onMenuShareTimeline',
							'onMenuShareAppMessage',
							'onMenuShareQQ',
							'startRecord',
							'stopRecord',
							'onRecordEnd',
							'playVoice',
							'pauseVoice',
							'stopVoice',
							'uploadVoice',
							'downloadVoice',
							'chooseImage',
							'previewImage',
							'uploadImage',
							'downloadImage',
							'getNetworkType',
							'openLocation',
							'getLocation',
							'hideOptionMenu',
							'showOptionMenu',
							'closeWindow',
							'scanQRCode'
						] // 必填，需要使用的JS接口列表，所有JS接口列表见附录2
				});

			}
		});
	}
});

/**
 * 打开微信拍照和相册  选择照片
 */
function chooseImage(counnt, func) {
	wx.chooseImage({
		count: counnt, // 默认9
		success: function(res) {
			images.localId = res.localIds;
			//alert('已选择 ' + res.localIds.length + ' 张图片');
			func();
		}
	});
}
/**
 * 上传图片
 * 返回url
 */
function uploadImage(func) {
	if(images.localId.length == 0) {
		func();
		return;
	}
	var i = 0,
	length = images.localId.length;
	images.serverId = [];

	function upload() {
		wx.uploadImage({
			localId: images.localId[i],
			isShowProgressTips: 1,
			success: function(res) {
				i++;
				//alert('已上传：' + i + '/' + length);
				images.serverId.push(res.serverId);
				
				if(i < length) {
					upload();
				}else{
					func();
				}
				
				
			},
			fail: function(res) {
				alert(JSON.stringify(res));
			}
		});
	}
	upload();
	
	

}
/**
 * 下载图片
 */
function downloadImage() {
	if(images.serverId.length === 0) {
		alert('请先使用 uploadImage 上传图片');
		return;
	}
	var i = 0,
		length = images.serverId.length;
	images.localId = [];

	function download() {
		wx.downloadImage({
			serverId: images.serverId[i],
			success: function(res) {
				i++;
				alert('已下载：' + i + '/' + length);
				images.localId.push(res.localId);
				if(i < length) {
					download();
				}
			}
		});
	}
	download();

}
/**
 * 扫一扫
 */
function scanQRCode(func) {
	wx.scanQRCode({
		needResult: 1,
		desc: 'scanQRCode desc',
		success: function(res) {
			
			//alert('==='+JSON.stringify(res.resultStr).replace(/\"/g,''));
			func(JSON.stringify(res.resultStr).replace(/\"/g,''));
			//func(res.resultStr);
		}
	});
}

/**
 * 分享给好友
 * @param {Object} title
 * @param {Object} desc
 * @param {Object} link
 * @param {Object} imgUrl
 */
function shareAppMessage(title,desc,link,imgUrl) {
	wx.onMenuShareAppMessage({
		title: title,
		desc: desc,
		link: link,
		imgUrl: imgUrl,
		trigger: function(res) {
			// 不要尝试在trigger中使用ajax异步请求修改本次分享的内容，因为客户端分享操作是一个同步操作，这时候使用ajax的回包会还没有返回
			//alert('用户点击发送给朋友');
		},
		success: function(res) {
			alert('已分享');
		},
		cancel: function(res) {
			alert('已取消');
		},
		fail: function(res) {
			alert(JSON.stringify(res));
		}
	});
	//alert('已注册获取“发送给朋友”状态事件');
}

/**
 * 分享到微信朋友圈
 * @param {Object} title
 * @param {Object} link
 * @param {Object} imgUrl
 */
function shareTimeline(title,link,imgUrl){
	 wx.onMenuShareTimeline({
      title: title,
		link: link,
		imgUrl: imgUrl,
      trigger: function (res) {
        // 不要尝试在trigger中使用ajax异步请求修改本次分享的内容，因为客户端分享操作是一个同步操作，这时候使用ajax的回包会还没有返回
      //  alert('用户点击分享到朋友圈');
      },
      success: function (res) {
        alert('已分享');
      },
      cancel: function (res) {
        alert('已取消');
      },
      fail: function (res) {
        alert(JSON.stringify(res));
      }
    });
}

/**
 * QQf分享
 * @param {Object} title
 * @param {Object} desc
 * @param {Object} link
 * @param {Object} imgUrl
 */
function shareQQ(title,desc,link,imgUrl){
	 wx.onMenuShareQQ({
      title: title,
		desc: desc,
		link: link,
		imgUrl: imgUrl,
      trigger: function (res) {
        alert('用户点击分享到QQ');
      },
      complete: function (res) {
        alert(JSON.stringify(res));
      },
      success: function (res) {
        alert('已分享');
      },
      cancel: function (res) {
        alert('已取消');
      },
      fail: function (res) {
        alert(JSON.stringify(res));
      }
    });
	
}

/**
 * 微博分享
 * @param {Object} title
 * @param {Object} desc
 * @param {Object} link
 * @param {Object} imgUrl
 */
function shareWeibo(title,desc,link,imgUrl){
	 wx.onMenuShareWeibo({
       title: title,
		desc: desc,
		link: link,
		imgUrl: imgUrl,
      trigger: function (res) {
        alert('用户点击分享到微博');
      },
      complete: function (res) {
        alert(JSON.stringify(res));
      },
      success: function (res) {
        alert('已分享');
      },
      cancel: function (res) {
        alert('已取消');
      },
      fail: function (res) {
        alert(JSON.stringify(res));
      }
    });
}

/**
 * QQ空間分享
 * @param {Object} title
 * @param {Object} desc
 * @param {Object} link
 * @param {Object} imgUrl
 */
function shareQZone(title,desc,link,imgUrl){
	wx.onMenuShareQZone({
      title: title,
		desc: desc,
		link: link,
		imgUrl: imgUrl,
      trigger: function (res) {
        alert('用户点击分享到QZone');
      },
      complete: function (res) {
        alert(JSON.stringify(res));
      },
      success: function (res) {
        alert('已分享');
      },
      cancel: function (res) {
        alert('已取消');
      },
      fail: function (res) {
        alert(JSON.stringify(res));
      }
    });
}



