/**
 * 初始化本地存储
 */
var Contact_chat;
var Message_chat;
function initDb(){
	if (window.openDatabase) { 
		persistence.store.websql.config(persistence, 'glz', 
		    '橄榄枝', 20 * 1024 * 1024); 
	}else { 
		persistence.store.memory.config(persistence); 
	}
	
	/*联系人表
	 *id,owner,emid,type,nickname,avatar,lastdate,lastmsg,status
	 *type-1：添加好友请求；2：系统消息；3：最近联系人
	 */
	Contact_chat = persistence.define('Contact_chat', {
		owner: "TEXT",
		emid: "TEXT",
		type: "TEXT",
		nickname: "TEXT",
		avatar: "TEXT",
		lastdate: "TEXT",
		lastmsg: "TEXT",
		status: "TEXT"
	});
	/*消息表
	 * id,emid,sender,type,content,createdate,status
	 * type-1：文本消息；2：表情消息；3：图片；4：命令；5：音频；6：位置；7：文件；8：视频
	 * */
	
	Message_chat = persistence.define('Message_chat', {
		owner: "TEXT",
		emid: "TEXT",
		sender: 'TEXT',
		type: "TEXT",
		content: "TEXT",
		createdate: "INT",
		status: "TEXT"
	});
	persistence.schemaSync();
}

/**
 * 清空数据库
 */
function resetDb(){
	var resetKey = "persistence-resetdb-1.3";
	
	var updated = localStorage.getItem(resetKey);
	console.info('重置数据库：'+updated);
	if(!updated){
		if(updated == 'true')
			return;
		
		initDb();
		
		persistence.reset(function() {
		  console.log("persistence Reset!");
		});
		localStorage.setItem(resetKey,true);
	}
	
}

function updateDefine(callback){
	if (window.openDatabase) { 
		persistence.store.websql.config(persistence, 'glz', 
		    '橄榄枝', 20 * 1024 * 1024); 
	}else { 
		persistence.store.memory.config(persistence); 
	}
	persistence.defineMigration(1, {
      up: function() {
      	this.executeSql('drop table Message_chat');
      },
      down: function() {
      }
    });
	persistence.defineMigration(2, {
      up: function() {
      	this.executeSql('drop table Message_chat');
//    	this.executeSql('drop table schema_version');
      },
      down: function() {
      }
    });
	function migrate( callback ){
	    console.log('migrating...');
	    persistence.migrations.init( function(){
	        console.log('migration init');
	        persistence.migrate( function(){
	            console.debug('migration complete!');
	            callback();
	        } );
	    });
	};
	
	migrate( onMigrationComplete );
	
	function onMigrationComplete(){
	    callback&&callback();
	};
}

/**
 * 数据提交-兼容LocalStorage模式
 */
function commitDb(){
	persistence.flush();
	if(!window.openDatabase){
		persistence.saveToLocalStorage(function() {
		  	console.log("memory data saved!");
		});
	}
}
/**
 * 加载数据库-兼容LocalStorage模式
 * @param {Object} callback
 */
function loadDb(callback){
	if(window.openDatabase){
		if(callback){
			callback();
		}
	}else{
		persistence.loadFromLocalStorage(function() {
		  	if(callback){
				callback();
			}
		});
	}
}

function test(){
	var tang = new User({name: "tang", age: 35});
	var wang = new User({name: "wang", age: 35});
	var tanghe = new User({name: "tanghe", age: 6});
	persistence.add(tang); 
	persistence.add(wang); 
	persistence.add(tanghe); 
	persistence.flush();
//	//localstorage:persistence.saveToLocalStorage and persistence.loadFromLocalStorage
//	persistence.saveToLocalStorage(function() {
//	  	console.log("All data saved!");
//	});
	
	var usersList = User.all().filter("age", '=', 35).order("name", false).limit(10);

	usersList.list(null, function (users) {
	    users.forEach(function (user) {
	        console.log(user.name);
	    });
	});
}
