/**
*数据库操作辅助类,定义对象、数据操作方法都在这里定义
*/
var dbname='glz';/*数据库名*/
var version = '1.0'; /*数据库版本*/
var dbdesc = '橄榄枝'; /*数据库描述*/
var dbsize = 20*1024*1024; /*数据库大小*/
var dataBase = null; /*暂存数据库对象*/
/*联系人表*
 *id,emid,type,nickname,avatar,lastdate,lastmsg,status
 *type-1：添加好友请求；2：系统消息；3：最近联系人
 */
var table_contact = "chat_contact";
/*消息表
 * id,emid,type,content,createdate,status
 * type-1：文本消息；2：表情消息；3：图片；4：命令；5：音频；6：位置；7：文件；8：视频
 * */
var table_message = "chat_message";

/**
 * 打开数据库
 * @returns  dataBase:打开成功   null:打开失败
 */
function websqlOpenDB(){
    /*数据库有就打开 没有就创建*/
    dataBase = window.openDatabase(dbname, version, dbdesc, dbsize,function() {});
    if (dataBase) {
        console.log("数据库创建/打开成功!");
    } else{
        console.log("数据库创建/打开失败！");
    }
    return dataBase;
}
/**
 * 新建表-联系人
 */
function creatTable_contact(){
//  chinaAreaOpenDB();
    var creatTableSQL = 'CREATE TABLE IF  NOT EXISTS '+ table_contact 
    + ' (id INTEGER PRIMARY KEY AUTOINCREMENT, emid text,type text,nickname text,avatar text,lastdate text,lastmsg text,status text)';
    dataBase.transaction(function (ctx,result) {
        ctx.executeSql(creatTableSQL,[],function(ctx,result){
            console.log("表创建成功 " + table_contact);
        },function(tx, error){ 
            console.log('创建表失败:' + table_contact + error.message);
        });
    });
}
/**
 * 新建表-消息表
 */
function creatTable_message(){
//  chinaAreaOpenDB();
    var creatTableSQL = 'CREATE TABLE IF  NOT EXISTS '+ table_message 
    + ' (id INTEGER PRIMARY KEY AUTOINCREMENT, emid text,type text,content text,createdate text,status text)';
    dataBase.transaction(function (ctx,result) {
        ctx.executeSql(creatTableSQL,[],function(ctx,result){
            console.log("表创建成功 " + table_message);
        },function(tx, error){ 
            console.log('创建表失败:' + table_message + error.message);
        });
    });
}
/**
 * 插入数据-联系人
 * @param emid:环信id
 * @param nickname:昵称
 * @param avatar:头像
 */
function inster_contact(emid,type,nickname,avatar){
    var insterTableSQL = "INSERT INTO " + table_contact + " (emid,type,nickname,avatar,lastdate,lastmsg,status) VALUES (?,?,?,?,'','','1')";
    dataBase.transaction(function (ctx) {
        ctx.executeSql(insterTableSQL,[emid,type,nickname,avatar],function (ctx,result){
            console.log("插入" + table_contact  + emid + "成功");
        },
        function (tx, error) {
            console.log('插入失败: ' + error.message);
        });
    });
}
/**
 * 插入数据-消息
 * @param emid:环信id
 * @param nickname:昵称
 * @param avatar:头像
 */
function inster_message(emid,type,content,createdate){
    var insterTableSQL = "INSERT INTO " + table_message + " (emid,type,content,createdate,status) VALUES (?,?,?,?,'1')";
    dataBase.transaction(function (ctx) {
        ctx.executeSql(insterTableSQL,[emid,type,content,createdate],function (ctx,result){
            console.log("插入" + table_message  + emid + "成功");
        },
        function (tx, error) {
            console.log('插入失败: ' + error.message);
        });
    });
}
/**
 * 执行sql
 * @param sql:sql语句
 * @param params:参数
 * @param callback:回调
 */
function execute(sql,params,callback){   
    var selectALLSQL = sql;
    dataBase.transaction(function (ctx) {
    	if (params ==null)
    		params = [];
        ctx.executeSql(selectALLSQL,params,function (ctx,result){
        	console.info(result);
        	if(callback){
        		callback(ctx,result);
        	}
        },
        function (tx, error) {
            console.log('查询失败: ' + error.message);
        });
    });
}